/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20140214-64 [Mar 29 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembly of ssdt9.dat, Sun Oct 25 14:45:31 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000479 (1145)
 *     Revision         0x02
 *     Checksum         0x14
 *     OEM ID           "Intel_"
 *     OEM Table ID     "IsctTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("ssdt9.aml", "SSDT", 2, "Intel_", "IsctTabl", 0x00001000)
{

    External (_SB_.IFFS.FFSS)
    External (_SB_.PCI0.LPCB.EC__.ECOK, IntObj)
    External (_SB_.PCI0.LPCB.EC__.FBUF)
    External (_SB_.PCI0.LPCB.EC__.FCMD)
    External (_SB_.PCI0.LPCB.EC__.FDAT)
    External (_SB_.PCI0.LPCB.EC__.INF2)
    External (_SB_.PCI0.LPCB.EC__.LIDS, IntObj)
    External (_SB_.PCI0.LPCB.EC__.WFNO)
    External (ICNF, IntObj)

    Scope (\_SB)
    {
        Device (IAOE)
        {
            OperationRegion (ISCT, SystemMemory, 0x92286E98, 0x000D)
            Field (ISCT, AnyAcc, Lock, Preserve)
            {
                WKRS,   8, 
                ISEF,   8, 
                FFSE,   8, 
                ITMR,   8, 
                ECTM,   32, 
                RCTM,   32, 
                ATOW,   8
            }

            Name (_HID, "INT33A0")  // _HID: Hardware ID
            Name (_CID, "PNP0C02")  // _CID: Compatible ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (IBT1, Zero)
            Name (IBT2, Zero)
            Name (INSB, Zero)
            Name (WTMS, Zero)
            Name (AWT0, Zero)
            Name (AWT1, Zero)
            Name (AWT2, Zero)
            Name (PTSL, Zero)
            Name (SLPD, Zero)
            Name (IMDS, Zero)
            Name (IWDT, Zero)
            Method (GABS, 0, NotSerialized)
            {
                Return (ICNF)
            }

            Method (GAOS, 0, NotSerialized)
            {
                Return (Or (And (IBT1, One), And (IMDS, 0x06)
                    ))
            }

            Method (SAOS, 1, NotSerialized)
            {
                Store (And (Arg0, 0x06), IMDS)
                And (IBT1, 0xFE, Local0)
                Or (Local0, And (Arg0, One), Local0)
                Store (Local0, IBT1)
                If (And (IBT1, One))
                {
                    Or (\_SB.PCI0.LPCB.EC.INF2, 0x80, \_SB.PCI0.LPCB.EC.INF2)
                }
                Else
                {
                    And (\_SB.PCI0.LPCB.EC.INF2, 0x7F, \_SB.PCI0.LPCB.EC.INF2)
                    Store (0xC2, \_SB.PCI0.LPCB.EC.FDAT)
                    Store (0xA6, \_SB.PCI0.LPCB.EC.FBUF)
                    Store (0xB8, \_SB.PCI0.LPCB.EC.FCMD)
                }
            }

            Method (GANS, 0, NotSerialized)
            {
                Return (INSB)
            }

            Method (SANS, 1, NotSerialized)
            {
                Store (And (Arg0, One), INSB)
            }

            Method (GWLS, 0, NotSerialized)
            {
                If (LEqual (And (ICNF, 0x04), Zero))
                {
                    Return (Zero)
                }

                Return (And (IBT1, 0x0F))
            }

            Method (SWLS, 1, NotSerialized)
            {
                If (LEqual (And (ICNF, 0x04), Zero))
                {
                    Return (Zero)
                }

                If (LEqual (ITMR, One))
                {
                    Store (And (And (Arg0, 0x0E), IBT1), IBT1)
                }
                Else
                {
                    Store (IBT1, Local0)
                    And (Local0, 0xF1, Local0)
                    Or (Local0, And (Arg0, 0x0E), Local0)
                    If (CondRefOf (\_SB.IFFS.FFSS))
                    {
                        If (LAnd (And (\_SB.IFFS.FFSS, 0x03), And (Arg0, 0x02)))
                        {
                            Or (Local0, 0x04, Local0)
                        }
                    }

                    Store (Local0, IBT1)
                }

                Or (IBT1, 0x04, IBT1)
            }

            Method (GWWS, 0, NotSerialized)
            {
                If (LEqual (And (ICNF, 0x08), Zero))
                {
                    Return (Zero)
                }

                ShiftRight (And (IBT1, 0xF0), 0x04, Local0)
                Return (Local0)
            }

            Method (SWWS, 1, NotSerialized)
            {
                If (LEqual (And (ICNF, 0x08), Zero))
                {
                    Return (Zero)
                }

                If (LEqual (ITMR, One))
                {
                    ShiftLeft (And (And (Arg0, 0x0E), IBT1), 0x04, IBT1)
                }
                Else
                {
                    Store (IBT1, Local0)
                    And (Local0, 0x8F, Local0)
                    Or (Local0, ShiftLeft (And (Arg0, 0x0E), 0x04), Local0)
                    If (CondRefOf (\_SB.IFFS.FFSS))
                    {
                        If (LAnd (And (\_SB.IFFS.FFSS, 0x03), And (Arg0, 0x02)))
                        {
                            Or (Local0, 0x40, Local0)
                        }
                    }

                    Store (Local0, IBT1)
                }

                Or (IBT1, 0x40, IBT1)
            }

            Method (SASD, 1, Serialized)
            {
                If (LAnd (And (ICNF, 0x10), LGreater (Arg0, Zero)))
                {
                    If (LEqual (ITMR, One))
                    {
                        Store (Arg0, RCTM)
                    }
                    Else
                    {
                        Store (Arg0, ECTM)
                    }

                    Store (And (ECTM, 0xFF), AWT0)
                    Store (ShiftRight (And (ECTM, 0xFF00), 0x08), AWT1)
                    Store (ShiftRight (And (ECTM, 0x00FF0000), 0x10), AWT2)
                    Store (WTMS, Local0)
                    Store (Or (0x81, Local0), WTMS)
                }
                Else
                {
                    Store (Arg0, SLPD)
                }
            }

            Method (GPWR, 0, NotSerialized)
            {
                Store (WKRS, Local0)
                If (LEqual (ITMR, Zero))
                {
                    If (\_SB.PCI0.LPCB.EC.ECOK)
                    {
                        If (LEqual (\_SB.PCI0.LPCB.EC.WFNO, 0x05))
                        {
                            Store (0x02, Local0)
                        }
                    }
                }

                If (And (Local0, 0x1F))
                {
                    Return (Local0)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (GPCS, 0, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC.ECOK)
                {
                    Return (\_SB.PCI0.LPCB.EC.LIDS)
                }
                Else
                {
                    Return (One)
                }
            }

            Method (GAWD, 0, NotSerialized)
            {
                Return (IWDT)
            }

            Method (SAWD, 1, NotSerialized)
            {
                Store (Arg0, IWDT)
            }
        }
    }
}

